﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Diagnostics;
using System.IO;
using Syncfusion.PdfViewer.Mvc;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Drawing;

namespace PdfViewerDemo.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        
        public ActionResult Index(string PdfFiles)
        {
            
            string path = Request.PhysicalPath.ToLower();
            path = path + "/Data/Barcode.pdf";
            PdfPrint(path);
            FileStream str = new FileStream(path, FileMode.Open, FileAccess.Read, FileShare.Read);
            ViewData["filestr"] = str;
            if (this.HttpContext.Request.IsAjaxRequest())
                return PartialView("PdfPartialView", ViewData);
            return View();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index(PdfViewerParams param)
        {
            if (param.FileStream != null)
            {
                byte[] bytearray = System.Convert.FromBase64String(param.FileStream);
                MemoryStream str = new MemoryStream(bytearray);
                ViewData["filestr"] = str;
            }
            ViewData["PdfParam"] = param;
            if (this.HttpContext.Request.IsAjaxRequest())
                return PartialView("PdfPartialView", ViewData);

            return View();
        }

        private void PdfPrint(string fileName)
        {
            var client = new PdfViewerMvc4Demo.ServiceReference1.Service1Client("BasicHttpBinding_Service1");
            string path = Request.PhysicalPath.ToLower();
            path = path + "/Data/Barcode.pdf";
            client.GetPdfImage(path);
        }
    }
}
