﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Threading;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;

using Syncfusion.Pdf.HtmlToPdf;
using System.ServiceModel.Activation;
using System.Drawing;
using Syncfusion.Pdf.Security;
using Syncfusion.Windows.Forms.PdfViewer;
using System.Windows.Media.Imaging;

using System.Text.RegularExpressions;
using System.Drawing.Printing;
namespace PdfService
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]

    public class Service1
    {
        string path;
        byte[] outputfile;

        Bitmap[] bitmap;

        public string GetData(int value)
        {
            return string.Format("You entered: {0}", value);
        }
        
        public void print(string filePath)
        {

        }

        /// <summary>
        /// Generates the image of the first page of the PDF document 
        /// </summary>
        /// <param name="filePath">path of the PDF document</param>
        /// <returns>Byte array of the image of the first page of the PDF document</returns>
        [OperationContract]
        public void GetPdfImage(string filePath)
        {
            page = 0;
            if (page < 0)
            {
                page = 0;
            }
            Bitmap[] bitmap;
            MemoryStream stream = new MemoryStream();
           // Image resized = null;
            //if (Regex.IsMatch(filePath, @"^.*\.(pdf|PDF)$"))
            {
                PdfDocumentView documentView = new PdfDocumentView();
                documentView.Load(filePath);
                if (page > documentView.PageCount - 1)
                {
                    page = documentView.PageCount-1;
                }
                bitmap = documentView.ExportAsImage(0, documentView.PageCount-1);
               
            }
            for (int i = 0; i < bitmap.Length; i++)
            {
            
                stream = new MemoryStream();
                bitmap[i].Save(stream, System.Drawing.Imaging.ImageFormat.Jpeg);
                Image img = Image.FromStream(stream);
                img.Save(System.IO.Path.GetFullPath(@"C:\Temp") + "\\myImage"+i+".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
            }
        
        }


        /// <summary>
        /// Generates the image of the first page of the PDF document 
        /// </summary>
        /// <param name="filePath">path of the PDF document</param>
        /// <returns>Byte array of the image of the first page of the PDF document</returns>
        [OperationContract]
        public void GetPdfPrint(string filePath)
        {
            if (Regex.IsMatch(filePath, @"^.*\.(pdf|PDF)$"))
            {
                PdfDocumentView documentView = new PdfDocumentView();
                documentView.Load(filePath);
                documentView.PrintDocument.Print();

                //Bitmap[] bmaps = documentView.ExportAsImage(0, documentView.PageCount - 1);
                //bitmap = bmaps;
                //PrintDocument pd = new PrintDocument();
                //pd.PrintPage += PrintPage;
                //pd.Print();
            }
        }
        int page = 0;
        private void PrintPage(object o, PrintPageEventArgs e)
        {
            
            System.Drawing.Image img = bitmap[page]; 
            page++;
            Point loc = new Point(0, 0);
            e.Graphics.DrawImage(img, loc);
            if (page < bitmap.Length)
                e.HasMorePages = true;
        }

        /// <summary>
        /// Resizes the input image to the dimension mentioned by the width and the height given
        /// </summary>
        /// <param name="imgPhoto">Input image</param>
        /// <param name="width">New Width</param>
        /// <param name="height">New Height</param>
        /// <returns>Resized image</returns>
        static Image ScaleImage(Image imgPhoto, int width, int height)
        {
            int sourceWidth = imgPhoto.Width;
            int sourceHeight = imgPhoto.Height;
            int destWidth = 0;
            int destHeight = 0;

            if (imgPhoto.Height > height)
            {
                float perc = (float)height / (float)imgPhoto.Height;
                destWidth = Convert.ToInt16(sourceWidth * perc);
                destHeight = Convert.ToInt16(sourceHeight * perc);
                if (destWidth > width)
                {
                    perc = (float)width / (float)imgPhoto.Width;
                    destWidth = Convert.ToInt16(sourceWidth * perc);
                    destHeight = Convert.ToInt16(sourceHeight * perc);
                }
            }
            else if (imgPhoto.Width > width)
            {
                float perc = (float)width / (float)imgPhoto.Width;
                destWidth = Convert.ToInt16(sourceWidth * perc);
                destHeight = Convert.ToInt16(sourceHeight * perc);
                if (destHeight > height)
                {
                    perc = (float)height / (float)imgPhoto.Height;
                    destWidth = Convert.ToInt16(sourceWidth * perc);
                    destHeight = Convert.ToInt16(sourceHeight * perc);
                }
            }
            else
            {
                destWidth = sourceWidth;
                destHeight = sourceHeight;
            }

            int sourceX = 0;
            int sourceY = 0;

            int destX = 0;
            int destY = 0;


            Bitmap bmPhoto = new Bitmap(destWidth, destHeight, System.Drawing.Imaging.PixelFormat.Format32bppPArgb);
            bmPhoto.SetResolution(imgPhoto.HorizontalResolution,
                                    imgPhoto.VerticalResolution);

            Graphics grPhoto = Graphics.FromImage(bmPhoto);
            grPhoto.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;

            grPhoto.DrawImage(imgPhoto,
                new System.Drawing.Rectangle(destX, destY, destWidth, destHeight),
                new System.Drawing.Rectangle(sourceX, sourceY, sourceWidth, sourceHeight),
                GraphicsUnit.Pixel);

            grPhoto.Dispose();
            return bmPhoto;
        }

    }
}
